;-------------------------------------------------------------------------------
;    Mascovy IRC Simulator (Remote Console) By Mascovy
;
;     Description : This remote console will able you to communicate / command
;                   IRC Simulator Server.
;
;         Help / Support : see Documentation
;
;    Comment/error/bug/etc to mindforce83@yahoo.com
; This Console Safe to run With Other Script ... No need to be stand alone...
;-------------------------------------------------------------------------------
on 1:load:echo -s Successfull Load IRC Simulator Version 2.0 .. | simstart
menu * {
  -
  $iif(!$window(@console),IRC Simulator Console):simstart
  -
}
alias console {
  unset %line* %go %system.ping
  if ($hget(config,console)) hdel config console 
  if (!$window(@Console)) { window -aBhkpdw +tbn @Console 100 250 380 348 " $+ $scriptdir\icon\setup.ico"  | drawfill -r @Console 13160660 1 1 100 }
  drawrect -pb @Console 1 1 10 14 350 270
  drawfill -pb @Console 0 1 10 14 350 270
  drawtext -prb @Console 1 $rgb(face) "verdana" 12 259 300   $str($chr(160),8) Info
  drawtext -prb @Console 1 $rgb(face) "verdana" 12 138 300  $str($chr(160),5) Config
  drawtext -prb @Console 1 $rgb(face) "Verdana" 12 25 300  $str($chr(160),4) Run/Stop
  drawpic -p @Console 18 295 110 20 20 20 " $+ $scriptdir\icon\tel.ico"
  drawpic -p @Console 140 295 106 18 20 20 " $+ $scriptdir\icon\setup.ico"
  drawpic -p @Console 268 295 114 28 20 20 " $+ $scriptdir\icon\info.ico"
  drawrect @Console 1 1 14 292 110 28
  drawrect @Console 1 1 134 292 110 28
  drawrect @Console 1 1 252 292 110 28
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 24 $str($chr(160),10) Remote Console For IRC Simulator
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 14 $str(-,80)
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 34 $str(-,80)
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 44 Server Up
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 56 Server Name
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 68 Total User
  drawtext -r @Console $rgb(shadow) "tahoma" 12 14 80 $str(-,80)
  titlebar @console ver 1.4  2004
  if (!$sock(myconsole*,1).status) {
    ectest Starting @ $fulldate
  }
  if ($sock(myconsole*,1).status)  ectest Ready & Connected to remote server
  mas.mdsn
}
alias mas.mdsn {
  if (!$window(@console)) return
  drawtext -b @Console 0 0 "tahoma" 12 90 44 : $str(-,60)
  drawtext -b @Console 0 0 "tahoma" 12 90 56 : $str(-,60)
  drawtext -b @Console 0 0 "tahoma" 12 90 68 : $str(-,60)
  var %xt = $3- , %dll = $calc($ctime - $ctime(%xt))
  drawtext -r @Console $rgb(shadow) "tahoma" 12 90 44 : %xt   $duration(%dll,3)
  drawtext -r @Console $rgb(shadow) "tahoma" 12 90 56 : $1
  drawtext -r @Console $rgb(shadow) "tahoma" 12 90 68 : $2

}
menu @Console {
  sclick:{
    if ($inrect($mouse.x,$mouse.y,14,292,110,28)) masc.serv.run
    if ($inrect($mouse.x,$mouse.y,134,292,110,28)) masc.open.dialog
    if ($inrect($mouse.x,$mouse.y,252,292,110,28)) masc.open.info
  }
  mouse:{
    if (!$inrect($mouse.x,$mouse.y,14,292,110,28))  { unset %do | drawrect @Console 1 1 14 292 110 28 }
    if (!$inrect($mouse.x,$mouse.y,134,292,110,28)) { unset %do | drawrect @Console 1 1 134 292 110 28 }
    if (!$inrect($mouse.x,$mouse.y,252,292,110,28)) { unset %do | drawrect @Console 1 1 252 292 110 28 }

    if ($inrect($mouse.x,$mouse.y,14,292,110,28)) {
      if (%do == 1) return
      set %do 1
      drawrect @Console 7 1 14 292 110 28
    }
    if ($inrect($mouse.x,$mouse.y,134,292,110,28)) {
      if (%do == 2) return
      set %do 2
      drawrect @Console 8 1 134 292 110 28
    }
    if ($inrect($mouse.x,$mouse.y,252,292,110,28)) {
      if (%do == 3) return
      set %do 3
      drawrect @Console 9 1 252 292 110 28
    }
  }
}
alias masc.serv.run {
  if ($sock(myconsole*,1).status) {
    var %t = $input(Server Is Running $crlf Are you sure you want to Terminate?,wy,Warning)
    if (%t == $true) {
      mascovy.query cmd: exit
      ectest INFO:Server Closed. | write -c ircsim.ini
      if ($hget(config,port)) hdel config port
      halt
    }
    if (%t != $true) halt
  }
  if (!$sock(myconsole*,1).status) {
    if (%cumm) halt
    ectest INFO:Attempt To Communicate to Remote Server
    cmircini
    set -u10 %cumm DOO
  }
}
alias masc.hello  { if (!$sock(myconsole*,1).status) {  if (!$hget(config,port)) return | if (!$portfree($hget(config,port))) { sockopen myconsole1 localhost $hget(config,port) | .timerfill 1 5 //mas.itek } } }
alias masc.open.info my.info
alias masc.open.dialog { if (!$sock(myconsole*,1).status) { ectest INFO:Not Connected to server | halt } | mascovy.query :Setup }
alias ectest {
  var %t = $1- , %x = 0 , %gone , %y = 0 , %num = 0 , %cdup = 0
  if ($width($1-,tahoma,12) < 270) { sync.txt --> $1- | return }
  while (%x < $numtok($1-,32)) {
    inc %x | inc %y | var %ter = %gone , %fl = $+(%x,-)
    %gone = $addtok(%gone,$gettok(%t,%y,32),32)
    if ($width(%gone,tahoma,12) > 270) {
      inc %num
      if (%cdup != 0) sync.txt %ter | if (%cdup == 0) sync.txt --> %ter  | inc %cdup |  %t = $gettok($1-,%fl,32)
      var %gone = $gettok(%t,1,32) , %y = 0
    }
  }
  if ((%gone) && ($width(%gone,tahoma,12) < 280)) {
    if (%cdup == 0) sync.txt --> %gone
    if (%cdup != 0) sync.txt %gone
  }
}
alias sync.txt {
  if (!$window(@Console)) return
  drawrect -pb @Console 0 1 10 14 350 270

  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 92 $str(-,80)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 104 $str(-,85)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 116 $str(-,85)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 128 $str(-,85)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 140 $str(-,85)

  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 152 $str(-,85)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 164 $str(-,85)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 178 $str(-,85)
  drawtext -rb @Console 16777215 16777215 "tahoma"  12 14 190 $str(-,85)


  if (%line.2) %line.1 = %line.2 | if (%line.1) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 92  %line.1 }
  if (%line.3) %line.2 = %line.3 | if (%line.2) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 104  %line.2 }
  if (%line.4) %line.3 = %line.4 | if (%line.3) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 116  %line.3 }
  if (%line.5) %line.4 = %line.5 | if (%line.4) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 128  %line.4 }

  if (%line.6) %line.5 = %line.6 | if (%line.5) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 140  %line.5 }
  if (%line.7) %line.6 = %line.7 | if (%line.6) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 152  %line.6 }
  %line.7 = $1- | if (%line.7) { drawtext -r @Console $rgb(shadow) "tahoma" 12 14 164  %line.7 }
}

alias graph {
  drawline -r @Console $rgb(face) 1 28 264 28 264 28 204
  drawline -r @Console $rgb(face) 1 28 266 339 266 28 266
  var %t = 0 , %o = 266
  while (%t < 7) {
    inc %t | dec %o 8
    if (%t == 1)  drawline -r @Console $rgb(face) 1 25 258 30 258 339 258
    if (%t != 1)  drawline -r @Console $rgb(face) 1 25 %o 30 %o 25 %o
  }
  var %c = 0 , %k = 28
  while (%c < 38) {
    inc %c | inc %k 8
    if (%c != 35) { drawline -r @Console $rgb(face) 1 %k 268 %k 268 %k 262 }
    if (%c == 35) { drawline @Console 12 1 %k 268 %k 268 %k 204 }
  }
  drawtext @Console 1 "tahoma" 10 25 270 Y = Sec X = Delay $str($chr(160),30) 1 scale = 2 sec
  drawtext -b @Console 0 0 "tahoma" 10 300 270 $str(-,10)
  drawtext @Console 1 "tahoma" 10 300 270 $asctime(hh:mm:ss)
  drawtext @Console 1 "tahoma" 10 15 250 0s
}

alias gin if ($1 == 0) return 308 258 | if ($istok(1.2,$1,46)) return 308 250 | if ($istok(3.4,$1,46)) return 308 242 | if ($istok(5.6,$1,46)) return 308 234 | if ($istok(7.8,$1,46)) return 308 226 | if ($istok(9.10,$1,46)) return 308 218 | if ($1 > 10) return 308 210
alias mcal {
  var %g = $gin($1) , %rec
  if (!$window(@Console)) return
  drawline -r @Console $rgb(face) 1 25 258 30 258 339 258
  drawtext -b @Console 0 0 "tahoma" 10 300 270 $str(-,10)
  drawtext @Console 1 "tahoma" 10 300 270 $asctime(hh:mm:ss)
  drawtext -b @Console 0 0 "tahoma" 11 320 225 $str(-,10)
  drawtext @Console 1 "tahoma" 11 320 225 Idle: $+ $1 $+ s
  if (%go) {
    graph
    var %k = 0
    while (%k < $numtok(%go,44)) {
      inc %k | var %jom = $gettok(%go,%k,44) , %temp = $gettok(%go,$calc(%k + 1),44)
      drawline @Console 0 2 %jom %temp %jom
    }
    if ($numtok(%go,44) > 35) %go = $gettok(%go,2-,44)
    var %c = 0
    while (%c < $numtok(%go,44)) {
      inc %c | var %hop = $gettok(%go,%c,44) , %hei = $calc($gettok(%hop,1,32) - 8) $gettok(%hop,2,32)
      %rec = $addtok(%rec,%hei,44)
    }
    %go = $addtok(%rec,%g,44)
  }
  if (!%go) set %go %g
  var %k = 0
  while (%k < $numtok(%go,44)) {
    inc %k | var %jom = $gettok(%go,%k,44) , %temp = $gettok(%go,$calc(%k + 1),44)
    drawline @Console 4 2 %jom %temp %jom
  }
}
alias simstart {
  set %ping.system 1
  if (!$window(@Console)) Console
  graph | .timerrecon 0 5 //masc.hello
}
alias hand.pro { 
  if (!$1) return 
  if (!$isid) { 
    if ($hget(config,console)) hadd config console $+($hget(config,console),$chr(9),$1-)
    if (!$hget(config,console)) hadd -m config console $1
  }
  if ($isid) return $gettok($hget(config,console),$+(-,$1),9) 
}
on 1:keydown:@Console:*:{
  drawtext -b @Console 0 0 "tahoma" 12 14 178 $str(-,80)
  if ($keyval == 13) {
    var %tom = %mas.input | unset %mas.input
    if (%tom) { ectest [CMD] %tom | if (!$sock(myconsole*,1).status) ectest ERROR:Not Connected to server | hand.pro %tom | unset %mas.count | mascovy.query cmd: %tom | halt }
  }
  if ($len(%mas.input) > 45) halt
  if ($keyval == 8) { $iif($len(%mas.input) == 1,unset %mas.input,set %mas.input $left(%mas.input,$calc($len(%mas.input) - 1)))  | goto ok }
  if ($keyval != 32) %mas.input = $+(%mas.input,$keychar)
  if ($keyval == 32) %mas.input = %mas.input $keychar
  if ($keyval == 38) { if (%mas.count != $numtok($hget(config,console),9)) inc %mas.count 1 | %mas.input = $hand.pro(%mas.count) }
  if ($keyval == 40) && (%mas.count > 1) {  dec %mas.count 1 | %mas.input = $hand.pro(%mas.count) }
  :ok
  if (%mas.input) drawtext -r @Console $rgb(frame) "Georgia" 12 14 178 %mas.input
}
alias mascovy.query if ($sock(myconsole*,1).status) sockwrite -nf myconsole* $1-
alias mas.itek if (!$sock(myconsole*,1).status) ectest ERROR:Connection Fail.. Reattempt! | return
on 1:sockopen:myconsole*:{
  if ($sockerr) return
  sockwrite -nf $sockname C: $ctime
  sockwrite -nf $sockname O:
  sockwrite -nf $sockname K:
}
on 1:sockclose:myconsole*:ectest WARNING:Connection To Remote Lost! | if ($hget(config,port)) hdel config port
on 1:sockread:myconsole*:{
  if ($sockerr) return
  var %sdr | sockread %sdr | tokenize 32 %sdr
  if (!$timer(sidle)) .timersidle 0 4 /mas.dde mascovy.query PING:
  if (E: iswm $1) { ectest ERROR: $+ $2- | halt }
  if (O: iswm $1) { ectest NOTICE: $+ $2- | halt }
  if (h: iswm $1) { ectest HELP: $+ $2- | halt }
  if (p: iswm $1) { set %ping.system $sock($sockname).lr | halt }
  if (i: iswm $1) { ectest INFO: $+ $2- | halt }
  if (s: iswm $1) { mas.mdsn $2 $3 $iif($4,$4-,$fulldate) | halt }
  if (r: iswm $1) { ectest $2- | halt }
  if (k: iswm $1) { ectest Client Port: $2- | halt }
}
alias mas.dde {
  if (%ping.system < 30) inc %ping.system
  if (%ping.system > 30) set %ping.system 30
  if (%ping.system < 1) set %ping.system 0
  if (!$sock(myconsole*,1).status) set %ping.system 0
  if (%ping.system) { mcal %ping.system }
  mascovy.query P: | mascovy.query s:
}
alias cmircini {
  if ($hget(config,port)) { var %t = $input(Server Already Running... Close This ALL mIRC if you need to load $crlf $+ Fresh Mascovy IRC Simulator,wo,Status Error) | halt }
  write -c ircsim.ini
  dimm afiles n0 $scriptdirircsim.ini
  dimm rfiles n0 $scriptdirircsim.ini
  dimm rfiles n1 $scriptdirircsim.ini
  dimm rfiles n2 $scriptdirircsim.ini
  dimm dde ServerStatus on
  dimm dde ServiceName ircsimulator
  dimm dde CheckName on
  dimm options n1 5,100,0,0,0,0,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,1,1,0,5,0,1,0,0,0,1,0,0,0,1,10
  dimm options n2 0,0,0,1,1,1,1,1,0,60,120,0,0,1,0,0,1,1,0,120,20,10,0,1,1,0,0,1,0,0,0,0,0,0,1,0
  dimm options n6 0,1,1,1,1,0,0,0,0,1,0,1,1,0,0,0,0,1,0,0,0,0,100,0,1,0,1,0,0,1,5,1,1,1,0
  dimm - - $ddename
  var %sd = 0 , %p = 5001.5002.5003.5004.5005 , %gox = $rand(12345,23456)
  while (%sd < $numtok(%p,46)) { inc %sd | if ($portfree($gettok(%p,%sd,46))) var %fr = $gettok(%p,%sd,46) }
  if (%fr) { dimm dde listen %fr | hadd -m config port %fr }
  if (!%fr) { dimm dde listen %gox | hadd -m config port %gox }
  run -n $mircexe ircsim.ini
}
alias -l dimm writeini ircsim.ini $1-
dialog aboutme {
  title "About Mascovy IRC Simulator"
  size -1 -1 114 49
  option dbu
  box "", 1, 1 1 112 47
  text "Mascovy IRC Simulator v2.0 Copyright  2004 Mascovy", 2, 31 9 75 15
  link "mindforce83@yahoo.com", 3, 32 26 71 8
  link "http://mascovy.tripod.com/", 4, 32 35 70 8
  icon 5, 7 17 20 18, $mircexe , 18
}
alias -l my.info if (!$dialog(aboutme)) dialog -ma aboutme aboutme
on 1:dialog:aboutme:sclick:*:if ($did == 3) .run mailto:mindforce83@yahoo.com | if ($did == 4) .run http://mascovy.tripod.com/
